//***********************************
//*       WATCOM C++ version of MCGA.CPP library for SOKOBAGER     
//*                        (c) 1999 by ToMaS
//****************************************************************************
#include <i86.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#define getmax_x 320
#define getmax_y 200
  typedef unsigned char byte;
  typedef unsigned int  word;

//**************************************************************************
void setmcga();
void settext();
void putpixel(int x, int y, int col);
int  getpixel(int x, int y);
void cls(int col);
void waitretrace();
void hline(int x,int xd,int y, unsigned char col);
void vline(int x,int y,int yd, unsigned char col);
void rectf(int x, int y, int xd, int yd, unsigned char col);
void set_rgb(int col, int r, int g, int b);
//**************************************************************************
     class pal{
        public:
           byte r[256], g[256], b[256];    
           void setrgb   (int col, int r, int g, int b);
           void loadpal  (char ime[]);
           void clr      ();
           void setpal   ();
     };
     class bmp {
       public:
          char *bmpbuf;
          word bmp_x, bmp_y;
          pal barva;
          byte trans;
          void loadbmp  (char ime[], byte ps, char ost);
          void putbmp   (word x, word y);
          void freebmp  ();
          void setpal   ();
       private:
          byte tom;byte psz;
          long filesize(FILE *stream);
  };
char *VGAMEM;
//****** SET SINGLE COLOR TO RED GREEN BLUE *********************************
void pal::setrgb(int col, int r, int g, int b)
{  set_rgb(col,r,g,b);}
//****** LOAD PALETTE FROM FILE *********************************************
void pal::loadpal(char ime[])
{ FILE *fp;
  int i;
  fp = fopen(ime, "rb");
  for(i=0;i<256;i++)
  {
    fread(&r[i],1,1,fp);r[i]/=4;
    fread(&g[i],1,1,fp);g[i]/=4;
    fread(&b[i],1,1,fp);b[i]/=4;
  }
  fclose(fp);
}
//****** CLEARS PALETTE *****************************************************
void pal::clr()
{ int i;
  for(i=0;i<256;i++)
  {
     r[i]=0;g[i]=0;b[i]=0;
  }
}
//****** ACTIVE PALETTE *****************************************************
void pal::setpal()
{ int i;
  for(i=0;i<256;i++)
  {
    setrgb(i,r[i],g[i],b[i]);
  }
}
//****** LOAD BMP PICTURE INTO MEMORY AND ALSO LOAD PALETTE *****************
void bmp::loadbmp(char ime[], byte ps, char ost)
{
  FILE *fp;int i, sizef;byte nul;
  byte tomi;
  psz=ps;
  tom=0;tomi=0;
  if((fp = fopen(ime, "rb"))==NULL){tomi=1;}
 if(tomi==0){
  fseek(fp, 18, SEEK_SET);fread(&bmp_x,2,1,fp);
  fseek(fp, 22, SEEK_SET);fread(&bmp_y,2,1,fp);
  fseek(fp, 54, SEEK_SET);
  for(i=0;i<256;i++)
  {
     fread(&barva.b[i],1,1,fp);barva.b[i]=barva.b[i]/4;
     fread(&barva.g[i],1,1,fp);barva.g[i]=barva.g[i]/4;
     fread(&barva.r[i],1,1,fp);barva.r[i]=barva.r[i]/4;
     fread(&nul ,1,1,fp);
  }
  tom=0;
  if((bmp_x*bmp_y)<=0xfff0)
  {
     tom=1;
     sizef=filesize(fp)-1078;
     if(sizef<bmp_x*bmp_y){bmpbuf=(char *)malloc(sizef);}
     else{bmpbuf=(char *)malloc(sizef);}
//     else{bmpbuf = new char[sizef];}
     fseek(fp, 1078, SEEK_SET);
     fread(bmpbuf,sizef,1,fp);
  }
  fclose(fp);
 }
}
//****** PLACE BMP PICTURE TO LOCATION ON SCREEN ****************************
void bmp::putbmp(word x, word y)
{
  int i,a,j=-1;byte col;
  for(a=0;a<bmp_y;a++){
    for(i=0;i<bmp_x;i++)
    { j++;
      col=*(bmpbuf+j);
      if(col!=trans)putpixel(x+i,y+bmp_y-a-1,col);
    }
    j+=psz;
  }
}
//****** FREE BMP PICTURE BUFFER ********************************************
void bmp::freebmp()
{
//  if(tom==1){delete[] bmpbuf;}
  if(tom==1){free(bmpbuf);}
}
//****** SET PICTURE PALETTE ACTIVE *****************************************
void bmp::setpal()
{
  barva.setpal();
}
//****** RETURNS FILESIZE OF FILE *******************************************
long bmp::filesize(FILE *stream)
{
    long curpos, length;

    curpos = ftell(stream);
    fseek(stream, 0L, SEEK_END);
    length = ftell(stream);
    fseek(stream, curpos, SEEK_SET);
    return length;
}
//****** SET MCGA GRAPHICS 320x200x8 ****************************************
void setmcga();
#pragma aux setmcga = \
    "   mov    ax,0x0013    "\
    "   int 0x10            "\
    modify [eax]
//****** SET TEXT ***********************************************************    
void settext();
#pragma aux settext = \
    "   mov    ax,0x0003    "\
    "   int 0x10            "\
    modify [eax]
//****** PLACE PIXEL TO GRAPHICS SCREEN *************************************    
void putpixel(int x, int y, int col);
#pragma aux putpixel = \
    "   mov edi,0xa0000     "\    
    "   push eax            "\
    "   xor al,al           "\
    "   mov ah,dl           "\
    "   shl dx,6            "\
    "   add dx,ax           "\
    "   add bx,dx           "\
    "   add edi,ebx         "\
    "   pop eax             "\
    "   stosb               "\
    parm [ebx] [edx] [eax] modify [ebx eax ecx edi]
//****** GETS PIXEL FROM SCREEN *********************************************
int getpixel(int x, int y)
{
   VGAMEM=(char *)(0xa0000);
   return (VGAMEM[y*320+x]);
}
//****** FILL VGA SCREEN WITH COL *******************************************    
void cls(int col);
#pragma aux cls = \
    "   mov edi,0xa0000     "\    
    "   mov cx,0x7d00       "\
    "   mov ah,al           "\
    "   rep stosw           "\
    parm [eax] modify [eax ecx edi]
//****** WAIT FOR WERTICAL RETRACE OF RAY ***********************************    
void waitretrace();
#pragma aux waitretrace = \
    "   mov dx,0x03da       "\
    "le:                    "\
    "   in  al,dx           "\
    "   and al,0x08         "\
    "   jnz le              "\
    "ld:                    "\
    "   in  al,dx           "\
    "   and al,0x08         "\
    "   jz  ld              "\
    modify [edx eax]
//****** HORIZONTAL LINE ****************************************************    
void hline(int x,int xd,int y, unsigned char col)
{
  int i;
  for(i=x;i<xd+1;i++){putpixel(i,y,col);}
}
//****** VERTICAL LINE ******************************************************
void vline(int x,int y,int yd, unsigned char col)
{
  int i;
  for(i=y;i<yd+1;i++){putpixel(x,i,col);}
}
//****** FILLED RECTANGLE ***************************************************
void rectf(int x, int y, int xd, int yd, unsigned char col)
{ int xo,yo;
  for(xo=x;xo<xd+1;xo++)
    for(yo=y;yo<yd+1;yo++)putpixel(xo,yo,col);
}
//****** REAL SETRGB ********************************************************
void set_rgb(int col, int r, int g, int b);
#pragma aux set_rgb = \
    "   mov bh,dl           "\
    "   mov dx,0x03c8       "\
    "   out dx,al           "\
    "   inc dx              "\
    "   mov al,bl           "\
    "   out dx,al           "\
    "   mov al,cl           "\
    "   out dx,al           "\
    "   mov al,bh           "\
    "   out dx,al           "\
    parm [eax] [ebx] [ecx] [edx] modify [eax ebx ecx edx]
//************************** <EOF MCGA.CPP> *********************************