#include <i86.h>
#include "mcga.cpp"
  typedef unsigned char byte;
  typedef unsigned int  word;

     class mis {
	    public:
			int  mx, my;
			int  levatipka, desnatipka;
			int  kazalec_nazaslonu;
			int  kazalec_vtx, kazalec_vty;
			char  *kazalec_podatki;
			int  miska_xo, miska_yo;
			char  *kazalec_podlaga;
			int  kazalec_prvic;
			byte barva[20];
			byte trans;

			mis(){kazalec_podatki=new char[500];kazalec_podlaga=new char[500];};
			~mis(){delete[] kazalec_podatki;delete[] kazalec_podlaga;};
			void dodaj(int y, char podatek[30]);
			void obcutljivost(unsigned int obcutljivost);
			void meja(int x, int y, int x0, int y0, int x1, int y1);
			int  instalirana();
			void nastavitve();
			void beri();
			void narisi(int miska_x, int miska_y);
			void brisi(int miska_x, int miska_y);
			void shranipodlago(int miska_x, int miska_y);
			void premikaj();
			void init();
			void vklopi();
			void izklopi();
			void cur_puscica();
			void cur_krizec();
			void cur_cakaj();
			void cur_roka();
	  };
void mis::obcutljivost(unsigned int obcutljivost)
{
  union REGS regs;

  regs.w.ax = 0x001a;                              //register ax=0x001a za dolocitev obcutljivosti miske
  regs.w.bx = obcutljivost;                        //v registra bx in cx vpisemo kaksno obcutljivost zelimo
  regs.w.cx = obcutljivost;
  regs.w.dx = 0x0001;
  int386(0x33, &regs, &regs);                       //klicemo interrupt 0x33-gonilnik miske, da spremenimo nastavitve obcutljivosti miske
}
void mis::meja(int x, int y, int x0, int y0, int x1, int y1)
{
  union REGS regs;
  regs.w.ax = 0x0007;                              //ax=0x0007 definiramo horizontalno omejitev kazalca miske
  regs.w.cx = x0;
  regs.w.dx = x1;
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik

  regs.w.ax = 0x0008;                              //ax=0x0008 definiramo vertikalno omejitev kazalca miske
  regs.w.cx = y0;
  regs.w.dx = y1;
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik

  regs.w.ax = 0x0004;                              //postavimo kazalec miske na doloceno pozicijo x,y
  regs.w.cx = x;
  regs.w.dx = y;
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik

  regs.w.ax = 0x000f;                              //ax=0x000f definiramo vsake koliko pik naj nam miskin gonilnik vraca vrednost pozicije kazalca
  regs.w.cx = 0x0008;
  regs.w.dx = 0x0008;
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik
}
int mis::instalirana()
{
  union REGS regs;

  regs.w.ax = 0x0000;
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik
  return regs.w.ax;
}
void mis::nastavitve()
{
  meja((getmax_x*8) / 2, (getmax_y*8) / 2, 0, 0, getmax_x*8, getmax_y*8);
  obcutljivost(0x00ff);
}
void mis::beri()
{
  union REGS regs;

  regs.w.ax = 0x0003;                              //ax=0x0003 beremo pozicijo miske in pritisnjenost gumbov
  int386(0x33, &regs, &regs);                       //klicemo 0x33-miskin gonilnik
  mx = regs.w.cx / 8;                         //shranimo dobljeno pozicijo miske
  my = regs.w.dx / 8;                         //v miska_x ter miska_y
  levatipka=0;desnatipka=0;            //preberemo iz registra bx se vrednosti tipk
  if (regs.w.bx==0x0002){levatipka=0;desnatipka=1;}
  if (regs.w.bx==0x0001){levatipka=1;desnatipka=0;}
  if (regs.w.bx==0x0003){levatipka=1;desnatipka=1;}
}
void mis::narisi(int miska_x, int miska_y)
{ int x,y,c,gx,gy,xt=20;
  gx=getmax_x;gy=getmax_y;
  for(y=0;y<xt;y++)
	{
	  for(x=0;x<xt;x++){
		 if( (kazalec_podatki[y*xt+x]!=trans) & (mx-kazalec_vtx+x>=0) & (miska_y-kazalec_vty+y>=0) & (miska_x-kazalec_vtx+x<gx) & (miska_y-kazalec_vty+y<gy))
			{
			  c=barva[kazalec_podatki[y*xt+x]];
//			  if(kazalec_podatki[y*xt+x]==2){c=8;}    //ce je 2 potem naj narise piko v sivi barvi
//			  if(kazalec_podatki[y*xt+x]==1){c=15;}   //ce je 1 potem naj narise piko v beli barvi
			  putpixel(miska_x-kazalec_vtx+x,miska_y-kazalec_vty+y,c);
			}
	  }
	}
}
void mis::brisi(int miska_x, int miska_y)
{ int x,y,gx,gy,xt=20;
  gx=getmax_x;gy=getmax_y;                       //shranimo x in y velikost zaslona
  for(y=0;y<xt;y++)
	{
	  for(x=0;x<xt;x++){                            //polje 10x10, ki je bilo prej pod kazalcem miske narisemo cez kazalec miske
		 if( (kazalec_podatki[y*xt+x]!=trans) & (miska_x-kazalec_vtx+x>=0) & (miska_y-kazalec_vty+y>=0) & (miska_x-kazalec_vtx+x<gx) & (miska_y-kazalec_vty+y<gy))
			{
			  putpixel(miska_x-kazalec_vtx+x,miska_y-kazalec_vty+y,kazalec_podlaga[y*xt+x]);
			}
	  }
	}

}
void mis::shranipodlago(int miska_x, int miska_y)
{ int x,y,gx,gy,xt=20;
  gx=getmax_x;gy=getmax_y;                      //shranimo x in y velikost zaslona
  for(y=0;y<xt;y++)
	{
	  for(x=0;x<xt;x++){                           //shranimo polje kjer bo postavljen kazalec miske, da ga bomo kasneje izbrisali s staro vsebino zaslona
		 if( (kazalec_podatki[y*xt+x]!=trans) & (miska_x-kazalec_vtx+x>=0) & (miska_y-kazalec_vty+y>=0) & (miska_x-kazalec_vtx+x<gx) & (miska_y-kazalec_vty+y<gy))
			{
			  kazalec_podlaga[y*xt+x]=getpixel(miska_x-kazalec_vtx+x,miska_y-kazalec_vty+y);
			}
	  }
	}
}
void mis::premikaj()
{
  if(kazalec_nazaslonu==1)                        //ce je kazalec na zaslonu potem naj z izvajanjem zacne
	 {
		beri();                               //preberemo podatke miske-kje se nahaja in status tipk
		if((mx!=miska_xo)|(my!=miska_yo))
		  {      waitretrace();
			 if(kazalec_prvic==0){brisi(miska_xo, miska_yo);}//ce kazalec je na zaslonu potem ga izbrisi, ker ga bomo postavili drugam
			 shranipodlago(mx, my);  //shranimo polje kamor bomo prilepili kazalec na zaslon, da ga bomo kasneje zopet izbrisali s podatki ki so pod kazalcem
			 narisi(mx, my);         //narisemo kazalec na zaslon
			 miska_xo=mx;miska_yo=my;      //stara lokacija miske se prepise z novo
			 kazalec_prvic=0;                        //kazalev je na zaslonu
		  }
	 }
}

void mis::vklopi()
{
  if(kazalec_nazaslonu==0){                       //ce kazalca se ni na zaslonu potem izvajaj program
	 beri();                                 //preberi koordinate miske
	 miska_xo=mx;
	 miska_yo=my;
	 kazalec_prvic=0;                              //kazalec bo po koncani proceduri na zaslonu
	 kazalec_nazaslonu=1;                          //kazalec na zaslonu
	 shranipodlago(mx, my);        //shranimo vsebino pod kazalcem
	 narisi(mx, my);               //narisemo kazalec
  }
}
void mis::izklopi()
{
  if(kazalec_nazaslonu==1){brisi(miska_xo, miska_yo);}//ce je kazalec na zaslonu potem izbrisi kazalec
  kazalec_prvic=1;                                //kazalec bo naslednjic postavljen sele prvikrat
  kazalec_nazaslonu=0;                            //kazalca ni vec na zaslonu
}
void mis::dodaj(int y, char podatek[30])
{
  int i,xt=20;
  for(i=0;i<xt;i++)                                //prenesemo besedo v polje stevil
	 {
		kazalec_podatki[(i)+(y*xt)]=podatek[i]-48;
	 }
}
void mis::cur_puscica()
{
  kazalec_vtx=0;                                   //vroca tocka kazalca-puscice je 0,0
  kazalec_vty=0;
  dodaj(0,"10000000000000000000");
  dodaj(1,"11000000000000000000");
  dodaj(2,"12100000000000000000");
  dodaj(3,"12210000000000000000");
  dodaj(4,"12221000000000000000");
  dodaj(5,"12221100000000000000");
  dodaj(6,"11110000000000000000");
  dodaj(7,"00121000000000000000");
  dodaj(8,"00121000000000000000");
  dodaj(9,"00010000000000000000");
 dodaj(10,"00000000000000000000");
 dodaj(11,"00000000000000000000");
 dodaj(12,"00000000000000000000");
 dodaj(13,"00000000000000000000");
 dodaj(14,"00000000000000000000");
 dodaj(15,"00000000000000000000");
 dodaj(16,"00000000000000000000");
 dodaj(17,"00000000000000000000");
 dodaj(18,"00000000000000000000");
 dodaj(19,"00000000000000000000");

}

void mis::cur_krizec()
{ int c,i;
  kazalec_vtx=5;                                   //vroca tocka kazalca-krizca je 5,5 sredina krizca
  kazalec_vty=5;
  dodaj(0,"00012100000000000000");
  dodaj(1,"00012100000000000000");
  dodaj(2,"00012100000000000000");
  dodaj(3,"11110111100000000000");
  dodaj(4,"22200022200000000000");
  dodaj(5,"11110111100000000000");
  dodaj(6,"00012100000000000000");
  dodaj(7,"00012100000000000000");
  dodaj(8,"00012100000000000000");
  dodaj(9,"00000000000000000000");
 dodaj(10,"00000000000000000000");
 dodaj(11,"00000000000000000000");
 dodaj(12,"00000000000000000000");
 dodaj(13,"00000000000000000000");
 dodaj(14,"00000000000000000000");
 dodaj(15,"00000000000000000000");
 dodaj(16,"00000000000000000000");
 dodaj(17,"00000000000000000000");
 dodaj(18,"00000000000000000000");
 dodaj(19,"00000000000000000000");
}
void mis::cur_cakaj()
{ int c,i;
  kazalec_vtx=5;                                   //vroca tocka kazalca-krizca je 5,5 sredina krizca
  kazalec_vty=5;
  dodaj(0,"11111111110000000000");
  dodaj(1,"10000000010000000000");
  dodaj(2,"10000200010000000000");
  dodaj(3,"01020020100000000000");
  dodaj(4,"00102001000000000000");
  dodaj(5,"00100201000000000000");
  dodaj(6,"01020202100000000000");
  dodaj(7,"10202020210000000000");
  dodaj(8,"12222222210000000000");
  dodaj(9,"11111111110000000000");
 dodaj(10,"00000000000000000000");
 dodaj(11,"00000000000000000000");
 dodaj(12,"00000000000000000000");
 dodaj(13,"00000000000000000000");
 dodaj(14,"00000000000000000000");
 dodaj(15,"00000000000000000000");
 dodaj(16,"00000000000000000000");
 dodaj(17,"00000000000000000000");
 dodaj(18,"00000000000000000000");
 dodaj(19,"00000000000000000000");

}
void mis::cur_roka()
{ int c,i;
  kazalec_vtx=6;                                   //vroca tocka kazalca-krizca je 5,5 sredina krizca
  kazalec_vty=0;
  dodaj(0,"00000111000000000000");
  dodaj(1,"00001444100000000000");
  dodaj(2,"00001242100000000000");
  dodaj(3,"00001222100000000000");
  dodaj(4,"00001222100000000000");
  dodaj(5,"00001222100000000000");
  dodaj(6,"00001222111000000000");
  dodaj(7,"00011222122100000000");
  dodaj(8,"00121222122211100000");
  dodaj(9,"00122552122212210000");
 dodaj(10,"01222222122212210000");
 dodaj(11,"01222222255212211000");
 dodaj(12,"01222222222225212100");
 dodaj(13,"00122222222222222100");
 dodaj(14,"00122222222222252100");
 dodaj(15,"00012222222222221000");
 dodaj(16,"00012222222222221000");
 dodaj(17,"00001222222222210000");
 dodaj(18,"00003333333333330000");
 dodaj(19,"00003333333333330000");

}

void mis::init()
{  int i;
	nastavitve();                    //nastavimo hitrost miske in omejitve miske
	kazalec_prvic=1;                       //1-kazalec se sploh ni bil narisan na zaslon
	kazalec_nazaslonu=0;                   //0-kazalca se ni na zaslonu
	trans=0;
	for(i=0;i<16;i++)barva[i]=i;
	cur_krizec();                        //kazalec naj bo krizec
}